
type filename = string
type dim = { width : int ; height : int }

type leaf =
  | Char of char
  | Picture of dim*filename

type 'a composite =
  | HBox of 'a list ref
  | VBox of 'a list ref

type glyph = Leaf of leaf | Composite of glyph composite
type composite_glyph = glyph composite

let rec intersects glyph x y =
  match glyph with
    | Leaf (Char c) -> (* STUB *) assert false
    | Leaf (Picture ({width;height},p)) ->
        0 <= x && x <= width &&
        0 <= y && y <= height
    | Composite (HBox r) | Composite (VBox r) ->
        List.exists (fun g -> intersects g x y) !r

let to_composite = function
  | Composite c -> Some c
  | Leaf _ -> None

let of_composite x = Composite x

let get_child container i =
  match container with
    | HBox r | VBox r -> List.nth !r i

let add_child container g =
  match container with
    | HBox r | VBox r -> r := g :: !r
